<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/include/HashBase.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_hash_base_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HashBase.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="structsiggen_1_1_hash_base.html">   10</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structsiggen_1_1_hash_base.html">HashBase</a></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="structsiggen_1_1_hash_base.html">HashBase</a> () { }</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structsiggen_1_1_hash_base.html#a6fa7d4e00b5564c1a9ee519409feeb98">GetSignatureSize</a> () <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structsiggen_1_1_hash_base.html#a969745d5499397d381f4d6d94478569b">CalculateSignature</a> (<span class="keywordtype">char</span> <span class="keyword">const</span> * data, <span class="keywordtype">size_t</span> size, <span class="keywordtype">char</span> * digest) <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">static</span> std::unique_ptr&lt;HashBase&gt; <a class="code" href="structsiggen_1_1_hash_base.html#a1f67711fe8ce2ae59a0fd8f33f6b51a2">Factory</a> (std::string <span class="keyword">const</span> &amp; name);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    };</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="astructsiggen_1_1_hash_base_html_a6fa7d4e00b5564c1a9ee519409feeb98"><div class="ttname"><a href="structsiggen_1_1_hash_base.html#a6fa7d4e00b5564c1a9ee519409feeb98">siggen::HashBase::GetSignatureSize</a></div><div class="ttdeci">virtual size_t GetSignatureSize() const =0</div><div class="ttdoc">returns size of the signature</div></div>
<div class="ttc" id="astructsiggen_1_1_hash_base_html"><div class="ttname"><a href="structsiggen_1_1_hash_base.html">siggen::HashBase</a></div><div class="ttdoc">base for cryptographic functions</div><div class="ttdef"><b>Definition:</b> <a href="_hash_base_8h_source.html#l00010">HashBase.h:10</a></div></div>
<div class="ttc" id="astructsiggen_1_1_hash_base_html_a1f67711fe8ce2ae59a0fd8f33f6b51a2"><div class="ttname"><a href="structsiggen_1_1_hash_base.html#a1f67711fe8ce2ae59a0fd8f33f6b51a2">siggen::HashBase::Factory</a></div><div class="ttdeci">static std::unique_ptr&lt; HashBase &gt; Factory(std::string const &amp;name)</div><div class="ttdoc">creates hash according to specified name</div><div class="ttdef"><b>Definition:</b> <a href="_hash_base_8cpp_source.html#l00011">HashBase.cpp:11</a></div></div>
<div class="ttc" id="astructsiggen_1_1_hash_base_html_a969745d5499397d381f4d6d94478569b"><div class="ttname"><a href="structsiggen_1_1_hash_base.html#a969745d5499397d381f4d6d94478569b">siggen::HashBase::CalculateSignature</a></div><div class="ttdeci">virtual void CalculateSignature(char const *data, size_t size, char *digest) const =0</div><div class="ttdoc">calculates signature of the block of data</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_5a30104352ef4255dc24354b02eb2d20.html">include</a></li><li class="navelem"><b>HashBase.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
